<%@page import="java.util.List"%>
<%@page import="org.openid4java.message.ax.AxMessage"%>
<%@page import="org.openid4java.message.ax.FetchResponse"%>
<%@page import="org.openid4java.message.AuthSuccess"%>
<%@page import="org.openid4java.discovery.Identifier"%>
<%@page import="org.openid4java.consumer.VerificationResult"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.Map"%>
<%@page import="org.openid4java.message.AuthRequest"%>
<%@page import="cz.cvut.felk.aos.openid.GoogleOpenIDHelper"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Google Openid Demo</title>
<style>
body {
	font-family: Sans-Serif;
	margin: 1em;
}

.openidDemo a, .openidDemo button {
	display: block;
	border-style: solid;
	border-color: #bbb #888 #666 #aaa;
	border-width: 1px 2px 2px 1px;
	background: #ccc;
	color: #333;
	line-height: 2;
	text-align: center;
	text-decoration: none;
	font-weight: 900;
	width: 13em;
}

.openidDemo pre {
	background: #ccc;
}

.openidDemo a:active, .openidDemo button:active {
	border-color: #666 #aaa #bbb #888;
	border-width: 2px 1px 1px 2px;
	color: #000;
}

.readme {
	padding: .5em;
	background-color: #F9AD81;
	color: #333;
}
</style>
</head>
<body>
    <div class="openidDemo">
        <%
            /*
            * The GoogleAuthHelper handles all the heavy lifting, and contains all "secrets"
            * required for constructing a google login url.
            */
            final GoogleOpenIDHelper helper = new GoogleOpenIDHelper();
            
            if (request.getParameter("logout") != null) {
                session.removeAttribute("openid");
                session.removeAttribute("openid-claimed");
                session.removeAttribute("email");
                session.removeAttribute("name");
            }
            
            if (session.getAttribute("openid") == null) {
                if (request.getParameter("openid.ns") == null) {

                    AuthRequest authReq = helper.getAuthReq(session, pageContext);
                    out.println("<form name=\"openid-form-redirection\" action=\""+authReq.getOPEndpoint()+"\" method=\"post\" accept-charset=\"utf-8\">");
                    Map pm=authReq.getParameterMap();
                    Iterator keyit=pm.keySet().iterator();

                    Object key;
                    Object value;

                    while (keyit.hasNext())
                    {
                        key=keyit.next();
                        value=pm.get(key);
                        out.println("<input type=\"hidden\" name=\""+key+"\" value=\""+value+"\" />");
                    }
                    
                    out.println("<div class=\"readme\">Firstly log to page</div>");
                    out.println("<button type=\"submit\">Log in with google</button>");
                    out.println("</form>");
                } else {
                   VerificationResult verification = helper.getVerificationResult(request, session, pageContext);

                    // examine the verification result and extract the verified identifier
                    Identifier verified = verification.getVerifiedId();
                    if (verified != null)
                    {
                        AuthSuccess authSuccess =
                                (AuthSuccess) verification.getAuthResponse();

                        session.setAttribute("openid", authSuccess.getIdentity());
                        session.setAttribute("openid-claimed", authSuccess.getClaimed());
                        response.sendRedirect(".");  // success
                        FetchResponse fetchResp = (FetchResponse) authSuccess
                        .getExtension(AxMessage.OPENID_NS_AX);

                        String firstName = fetchResp.getAttributeValue("FirstName");
                        String lastName = fetchResp.getAttributeValue("LastName");
                        List emails = fetchResp.getAttributeValues("email");
                        String email = (String) emails.get(0);
                            session.setAttribute("email", email);

                        session.setAttribute("name", firstName+" "+lastName);
                    }
                }
            } else {
                out.println("<p>Logged in as "+session.getAttribute("openid")+"</p>");
                out.println("<p>email address "+session.getAttribute("email")+"</p>");    
                out.println("<a href=\"?logout\">Log out</a>");
            }
      %>

    </form>
    </div>
</body>
</html>
